local cached = false

local function oper(v, fntname, fntpref, mono, space, height)
	rawset(_G, fntname, {monospace = mono, space = space, height = height})
	for i = 0,255 do
		local build = string.format(fntpref.."%03d", i)
		if v.patchExists(build) then
			--print(build)
			_G[fntname][i] = v.cachePatch(build)
		end
	end
end

// Run once to cache the whole font
hud.add(function(v,p,c)
	if FONT_CONSOLE == nil or FONT_CONSOLE[65] == nil or not FONT_CONSOLE[65].valid then cached = false end
	if cached then return end
	
	//oper("FONT_KART2", "MKFT2")
	//oper(v, "FONT_KART2", "MKFT2", 8)
	//oper(v, "FONT_TINY", "SMTYB", 3)
	//oper(v, "FONT_TINYDARK", "SMTYD", 3)
	//oper(v, "FONT_TITLE", "SMTTL", 6)
	
	oper(v, "FONT_CONSOLE", "STCFN", 8, 4, 8)
	oper(v, "FONT_CONSOLE2", "COLFN", 8, 4, 8)
	oper(v, "FONT_TINY2", "CTNFN", 4, 2, 8)
	
	cached = true
end, "game")


local styles = {
	"FS_SHADOW", // Draws another string right below this (useful for monocolor fonts)
	"FS_MONOSPACE", // Fixed width
	"FS_FIXED", // Enables scaling and places things in the fixed scale, epic!
	"FS_FIXEDPOS", // Position is multiplied by FRACUNIT
}
for i = 1,#styles do
	rawset(_G, styles[i], 2^(i-1))
end

rawset(_G, "drawStringMkII", function(v, x, y, str, font, flags, extra) // color, style, flags, align)
	local style,align,color,scale
	if extra ~= nil then
		color = extra.color
		style = extra.style
		//flags = extra.flags
		align = extra.align
		scale = extra.scale
	end
    //if str == "" then str = "-" end // Necessary even?
	if str == true then str = "true" end
	if str == false then str = "false" end
	if type(str) == "number" then str = tostring(str) end
	if type(str) ~= "string" then str = type(str) end
	
	if style == nil then style = 0 end
	if color == nil then color = 0 end
	if scale == nil then scale = FRACUNIT end
	
	if type(color) ~= "table" then
		color = {color}
	end
	
    local dt = {}
    local offset = 0
	local mono = font.monospace
    for i = 1,#str do
        local by = string.byte(str:sub(i,i))
		--print(by.." "..str:sub(i,i))
		local res = 0
		if font[by] ~= nil then
            dt[#dt+1] = {font[by], offset}
			local ew = font[by].width
			if (style & FS_MONOSPACE) then ew = mono end
			if (style & FS_FIXED) then ew = FixedMul(ew*FRACUNIT, scale) end
			-- FixedMul(ew*FRACUNIT, scale)
            offset = $ + ew
        else
			local mohere = mono
			if by == 32 then mohere = font.space end
			if (style & FS_FIXED) then mohere = FixedMul($*FRACUNIT, scale) end
            offset = $ + mohere
        end
		
		if (style & FS_MONOSPACE) then res = mono end
		if (style & FS_FIXED) then res = FixedMul(res*FRACUNIT, scale) end
		offset = $ + res
    end

    local eo = 0
    if align == "center" then
        eo = offset/2
    end
    if align == "right" then
        eo = offset
    end
	
	local vo = 0
	if extra.valign ~= nil and (style & FS_FIXED) then
		local height = FixedMul(font.height*FRACUNIT, scale)
		if extra.valign == "center" then
			vo = (height/2)
		end
	end
	
	local colormaps = {}
	for i = 1,#color do
		colormaps[i] = v.getColormap(TC_DEFAULT, color[i])
	end
	
	if (style & FS_FIXEDPOS) then x,y = $1*FRACUNIT,$2*FRACUNIT end
	
    for i = 1,#dt do
        local ix = dt[i]
		
		if (style & FS_FIXED) then
			if style & FS_SHADOW then
				v.drawScaled(x+ix[2]-eo+FRACUNIT, y+FRACUNIT, scale, ix[1], flags, colormaps[2])
			end
			v.drawScaled(x+ix[2]-eo, y-vo, scale, ix[1], flags, colormaps[1])
		else
			v.draw(x+ix[2]-eo, y, ix[1], flags, colormaps[1])
		end
		
    end
end)
