local CV_Sensible = {MIN = 0, MAX = 999}
local CV_Players = {MIN = 1, MAX = 32}

local function customWarning()
	if netgame then print("Essa configuracao sera aplicada somente no CustomWare.") end
end
local function debugWarning()
	if netgame then print("Essa configuracao sera aplicada somente no DebugWare.") end
end

local customFlags = CV_NETVAR|CV_SHOWMODIF|CV_CHEAT|CV_CALL
local debugFlags = CV_NETVAR|CV_CHEAT|CV_CALL

rawset(_G, "WCV", {
	force = CV_RegisterVar({"ware_force", "none", customFlags, nil, customWarning}),
	
	roundless = CV_RegisterVar({"ware_roundless", "No", debugFlags, CV_YesNo, debugWarning}),
	// Always round 1, for debugging
	
	instastart = CV_RegisterVar({"ware_instastart", "No", debugFlags, CV_YesNo, debugWarning}),
	// The game immediately starts when somebody enters, disregards waitplayers
	
	temposhift = CV_RegisterVar({"ware_temposhift", "Yes", 0, CV_YesNo}),
	// Experimental: Hacks the music so it plays fUCKING FASTE R !!!!!!!!!!!
	
	rounds = CV_RegisterVar({"ware_rounds", 21, customFlags, CV_Sensible, customWarning}),
	// How many rounds to play until the end of the game
	// Can be 0, in which case... it acts like 1 i think
	
	tillboss = CV_RegisterVar({"ware_toboss", 20, customFlags, CV_Sensible, customWarning}),
	// How many rounds between boss stages
	// This will reset speed to 0, and will override speedups
	// Can be 0, for no boss rounds
	
	tillspeed = CV_RegisterVar({"ware_tospeed", 5, customFlags, CV_Sensible, customWarning}),
	// How many rounds in between each speedup
	// Can be 0, for no speedups
	
	waitplayers = CV_RegisterVar({"ware_waitplayers", 2, CV_NETVAR|CV_SHOWMODIF, CV_Players}),
	// How many players to wait for before exiting the wait state
})

createEnum({
	"STG_ROUNDS",
	"STG_TOSPEED",
	"STG_TOBOSS",
})
local vals = {
	[STG_ROUNDS]    = WCV.rounds,
	[STG_TOSPEED] = WCV.tillspeed,
	[STG_TOBOSS]    = WCV.tillboss,
}
rawset(_G, "WARESETTINGS", vals) // For easy access
rawset(_G, "WARESETTING", function(v)
	// No, I can't make this a single line return because some values are 0 and 0 is interpreted as false
	if gametype == GT_WARE then
		return tonumber(vals[v].defaultvalue) // WHY IS IT NOT A VALUE ALREADY
	else return vals[v].value end
end)